# std::optional<T>::end

From cppreference.com
< cpp‎ | utility‎ | optional

constexpr iterator end() noexcept; |  | (since C++26)
constexpr const_iterator end() const noexcept; |  | (since C++26)

Returns a past-the-end iterator. Equivalent to return begin() + has_value();.

### Parameters

(none)

### Return value

Past-the-end iterator

### Complexity

Constant.

### Notes

Feature-test macro | Value | Std | Feature
--- | --- | --- | ---
`__cpp_lib_optional_range_support` | `202406L` | (C++26) | Range support for `std::optional`

### Example

Run this code

    #include <optional>
    #include <print>

    int main()
    {
        constexpr std::optional<int> none = std::nullopt; // optional @1
        constexpr std::optional<int> some = 42;           // optional @2

        static_assert(none.begin() == none.end());
        static_assert(some.begin() != some.end());

        // ranged-for loop support
        for (int i : none)
            std::println("Optional @1 has a value of {}", i);

        for (int i : some)
            std::println("Optional @2 has a value of {}", i);
    }

Output:

    Optional @2 has a value of 42

### See also

begin (C++26) | returns an iterator to the beginning (public member function)

Retrieved from "https://en.cppreference.com/mwiki/index.php?title=cpp/utility/optional/end&oldid=173893"